//
// IFDTag.java
//
// Copyright (C) 1999-2002 Takashi Koike
//
// Last Modified	: 2002/03/15
//
public class IFDTag {
	protected int	nTagNo;		// ^Oԍ
	protected int	nFormat;	// f[^tH[}bg
	protected long	lDataNum;	// f[^
	protected long	lDataOffset;// f[^ʒu
	final static int	nDataLen[] = { 1, 1, 2, 4, 8, 1, 1, 2, 4, 8, 4, 8 };	// f[^tH[}bg(ԍ-1)Ƃ̃f[^Pʒ
	final static int	nDataUnit[] = { 1, 1, 1, 1, 2, 1, 1, 1, 1, 2, 1, 2 };	// f[^tH[}bg(ԍ-1)Ƃ̃f[^\
	final static int	nEntryLen = 8;	// fBNgGg
	public static int	nDebugLevel;
	//
	// RXgN^
	//
	IFDTag() {
		this.nTagNo = this.nFormat = 0;
		this.lDataNum = this.lDataOffset = 0;
		IFDTag.nDebugLevel = 0;
	}
	IFDTag(byte[] buf, int nTiffOffset, int nOffset, boolean bIntel) {
		this();
		create(buf, nTiffOffset, nOffset, bIntel);
	}
	//
	// e탁\bh
	//
	boolean	create(byte[] buf, int nTiffOffset, int nOffset, boolean bIntel) {
		if (buf.length - nTiffOffset - nOffset < IFDTag.nEntryLen) {
			return	false;
		}
		// ^Oԍ
		this.nTagNo = (int)ReadByte.toLong(buf, nTiffOffset+nOffset, 2, bIntel);
		// f[^tH[}bg
		this.nFormat = (int)ReadByte.toLong(buf, nTiffOffset+nOffset+2, 2, bIntel);
		// f[^
		this.lDataNum = (long)ReadByte.toLong(buf, nTiffOffset+nOffset+4, 4, bIntel);
		// f[^ʒu
		if (IFDTag.nDataLen[nFormat-1]*this.lDataNum > 4) {
			this.lDataOffset = (long)ReadByte.toLong(buf, nTiffOffset+nOffset+8, 4, bIntel);
		}
		else {
			this.lDataOffset = nOffset+8;
		}
		if (nDebugLevel >= 3) { System.err.println("IFDTag.create() TagNo:" + nTagNo + " Format:" + nFormat + " DataNum:" + lDataNum + " DataOffset:" + lDataOffset);}
		return	true;
	}
	int		getTagNo() {
		return	this.nTagNo;
	}
	int		getFormat() {
		return	this.nFormat;
	}
	long	getDataNum() {
		return	this.lDataNum;
	}
	int		getDatumLen() {
		return	nDataLen[this.nFormat-1];
	}
	int		getDatumUnit() {
		return	nDataUnit[this.nFormat-1];
	}
	long	getDataOffset() {
		return	this.lDataOffset;
	}
}
