//
// MakeThumbFrame.java
//
// Copyright (C) 1999-2002 Takashi Koike
//
// Last Modified	: 2002/03/15
//
import	java.awt.event.*;
import	javax.swing.*;

class MakeThumbFrame extends JFrame {
	private MakeThumb	applet;
	final static String	strMenuOpenDir = "Open directory...";	// ufBNgJvj[
	//
	// RXgN^
	//
	public MakeThumbFrame(String name) {
		super(name);
		addWindowListener(new MakeThumbFrameWindowAdapter());
		//
		// j[
		//
		JPopupMenu.setDefaultLightWeightPopupEnabled(false);	// AWT+JMenup
		JMenuBar	mb = new JMenuBar();
		setJMenuBar(mb);
		JMenu	m = new JMenu("File");
		mb.add(m);
		JMenuItem	mi0 = new JMenuItem(MakeThumbFrame.strMenuOpenDir);
		mi0.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser	chooser = new JFileChooser();
				chooser.setDialogTitle("Select Directory");
				chooser.setDialogType(JFileChooser.OPEN_DIALOG);
				chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int	nRet = chooser.showOpenDialog(getContentPane());
				if(nRet == JFileChooser.APPROVE_OPTION) {
					String[]	strBaseDirs = new String[1];
					strBaseDirs[0] = chooser.getSelectedFile().getAbsolutePath();
					applet.windowApp(strBaseDirs);
				}
			}
		});
		m.add(mi0);
		m.addSeparator();
		JMenuItem	mi1 = new JMenuItem("Quit");
		mi1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		m.add(mi1);
		// X^[g
		applet = new MakeThumb();
		getContentPane().add("Center", applet);
		applet.init();
		applet.start();
	}
	class MakeThumbFrameWindowAdapter extends WindowAdapter {
		public void windowClosing(WindowEvent e) {
			applet.stop();
			applet.destroy();
			System.exit(0);
		}
	}
}
